package com.energy.online.data.crontab;

import com.alibaba.fastjson2.JSON;
import com.energy.online.data.common.CommonData;
import com.energy.online.data.dto.BaseConfig;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.List;
import java.util.Map;

@Component
public class TimeSaveScheduled {

    private static final SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");

    @Autowired
    private BaseConfig baseConfig;

    //    @Scheduled(cron = "0/1 * * * * *")
    @Scheduled(fixedRate = 1000)
    public void collectData() {
        CommonData.addList();
    }

    @Scheduled(cron = "0 0/1 * * * *")
    public void saveToFile() {
        List<Map<String, Object>> datas = CommonData.getListAndClean();
        if (!datas.isEmpty()) {
            String timestamp = sdf.format(System.currentTimeMillis());
            String fileName = baseConfig.getSaveDir() + timestamp + ".json";
            try (PrintWriter writer = new PrintWriter(fileName)) {
                writer.write(JSON.toJSONString(datas));
                writer.flush();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }
}
